# Copyright (c) 2011-2012  The Board of Trustees of The Leland Stanford Junior University
# Copyright (c) 2012  Barnstormer Softworks, Ltd.

import logging

FOAM_ROOT = "/opt/foam"

DB_PATH = "%s/db/geni-openflow.db" % (FOAM_ROOT)
CONFIGDB_PATH = "%s/db/config.db" % (FOAM_ROOT)

DB_ENGINE = "sqlite:///%s" % (DB_PATH)
CONFIGDB_ENGINE = "sqlite:///%s" % (CONFIGDB_PATH)

LOGLEVEL = logging.INFO
LOGFORMAT = "%(asctime)s [%(levelname)s] - %(message)s"
LOGDIR = "%s/log" % (FOAM_ROOT)
FOAMLOG = "%s/foam.log" % (LOGDIR)

PLUGINROOT = "%s/plugins" % (FOAM_ROOT)

TASKLOGDIR = "%s/tasks/" % (LOGDIR)
TASK_QUEUE_DIR = "%s/tasks/queue" % (FOAM_ROOT)
TASK_COMPLETED_DIR = "%s/tasks/completed" % (FOAM_ROOT)

TEMPLATE_DIR = "%s/etc/templates/default" % (FOAM_ROOT)
USER_TEMPLATE_DIR = "%s/etc/templates/custom" % (FOAM_ROOT)

try:
  from foamext.config import *
except ImportError:
  pass
