# Copyright (c) 2013-2017  Barnstormer Softworks, Ltd.

import logging

class CoreException(Exception):
  def __init__ (self):
    super(CoreException, self).__init__()
    self._foam_logged = False
    self._unexpected = True

  def log (self, logh, msg, level = logging.ERROR):
    logh.log(level, msg)
    logh.log(level, str(self))
    self._foam_logged = True

 
class UserException(CoreException):
  def __init__ (self):
    super(UserException, self).__init__()
    self._unexpected = False


class ProtectedDataException(CoreException):
  def __init__ (self):
    super(ProtectedDataException, self).__init__()
    self.__pdata = None

  def setProtectedMessage (self, msg):
    self.__pdata = msg

  def log (self, logh, msg = None, level = logging.ERROR):
    if self.__pdata is not None:
      if msg is not None:
        super(ProtectedDataException, self).log(logh, "%s\n%s" % (msg, self.__pdata), level)
      else:
        super(ProtectedDataException, self).log(logh, self.__pdata, level)
    else:
      super(ProtectedDataException, self).log(logh, msg, level)

