# Copyright (c) 2014  Barnstormer Softworks, Ltd.

import logging
import logging.handlers

from foam.config import LOGFORMAT, LOGDIR


class _LogManager(object):
  def __init__ (self):
    self._logs = {}
    self._modules = {}

  def get (self, key, module = None):
    # TODO:  Modules would be things like "geni-slice" and would contain all of the settings
    # for those types of logs (backup count, loglevel, location, etc.)
    if not self._logs.has_key(key):
      logger = logging.getLogger(key)
      lh = logging.handlers.RotatingFileHandler(os.path.normpath("%s/%s.log" % (LOGDIR, key)),
                                                maxBytes = 1000000, backupCount = 2)
      lh.setLevel(logging.DEBUG)
      lh.setFormatter(logging.Formatter(LOGFORMAT))
      self._logs[key] = logger
    return self._logs[key]


LogManager = _LogManager()
