# Copyright (c) 2012  Barnstormer Softworks Ltd.

class _Manager(object):
  def __init__ (self):
    self.DB = None
    self.enabled = False

  def init (self, app, configdb):
    self._app = app
    self._configdb = configdb

    self.enabled = configdb.getConfigItemByKey("plugin.dhcp-manager.enabled").getValue()
    if self.enabled:
      self.initCore()

  def initCore (self):
    from foam.dhcp.db import DB
    self.DB = DB

    self.conf_file_path = self._configdb.getConfigItemByKey("dhcp.isc3.conffile").getValue()
    self.db_file_path = self._configdb.getConfigItemByKey("dhcp.dbpath").getValue()

    import foam.dhcp.rpc
    foam.dhcp.rpc.setup(app)

    self.enabled = True

  def enable (self):
    self.initCore()
    
    
def setup (app):
  from foam.core.configdb import ConfigDB, ConfigItem

  citems = []
  citems.append(ConfigItem().setKey("plugin.dhcp-manager.enabled").setValue(False)
                .setDesc("Enable the DHCP Manager")
                .setUpdateFunName("foam.dhcp.manager.update"))
  citems.append(ConfigItem().setKey("dhcp.isc3.conffile").setValue("/etc/dhcp3/dhcpd.conf")
                .setDesc("Location of the ISC DHCPD configuration file on the local filesystem")
                .setUpdateFuncName("foam.dhcp.manager.update"))
  citems.append(ConfigItem().setKey("dhcp.isc3.default-lease-time").setValue(7200)
                .setDesc("Default Lease Time")
                .setUpdateFuncName("foam.dhcp.manager.update"))
  citems.append(ConfigItem().setKey("dhcp.isc3.max-lease-time").setValue(14400)
                .setDesc("Max lease time")
                .setUpdateFuncName("foam.dhcp.manager.update"))
  citems.append(ConfigItem().setKey("dhcp.isc3.log-facility").setValue("local7")
                .setDesc("Log facility")
                .setUpdateFuncName("foam.dhcp.manager.update"))
  [ConfigDB.installConfigItem(x) for x in citems]

  Manager.init(app, ConfigDB)

  import foam.dhcp.rpc
  foam.dhcp.rpc.setup(app)
