# Copyright (c) 2011-2012  The Board of Trustees of The Leland Stanford Junior University
# Copyright (c) 2012  Barnstormer Softworks, Ltd.

from foam.core.configdb import ConfigDB, ConfigItem
from foam.config import PLUGINROOT

class PluginManager(object):
  def __init__ (self, plugin_dir):
    self.plugin_root = plugin_dir
    self.__plugins = {}

    self._loadPlugins()

  def _loadPlugins (self):
    pass

  def getByInterface (self, interface):
    for v in self.__plugins.itervalues():
      if v.interfaces("foam.interface.rpc"):
        yield v

def setup (app):
  citems = []
  citems.append(ConfigItem().setKey("plugmgr.plugin-dir")
                .setValue(PLUGINROOT)
                .setDesc("Root directory for plugins"))
  [ConfigDB.installConfigItem(x) for x in citems]

  PM = PluginManager(ConfigDB.getConfigItemByKey("plugmgr.plugin-dir").getValue())
  return PM
