# Copyright (c) 2013-2016  Barnstormer Softworks, Ltd.

from __future__ import absolute_import

import uuid

from ..core import json

class UUID(json.JSONInput):
  @staticmethod
  def validate (obj):
    if not isinstance(obj, (str, unicode)):
      return False
    return True

  @staticmethod
  def construct (obj):
    return UUID(str(obj))
  
  def __init__ (self, val = None):
    if val:
      self._val = str(val)
    else:
      self._val = str(uuid.uuid4())

  def __str__ (self):
    return self._val

  def __json__ (self):
    return self._val

  def __hash__ (self):
    return hash(self._val)

  def __eq__ (self, other):
    return self._val == other._val

  def __neq__ (self, other):
    return self._val != other._val

  def __repr__ (self):
    return str(self)
