# Copyright (c) 2016  Barnstormer Softworks, Ltd.

from __future__ import absolute_import

from IPy import IP

POOLTYPES = {}

def pool (typ):
  def decorator(k):
    POOLTYPES[typ] = k
    return k
  return decorator
    
  
class AddressPool(object):
  def __init__ (self, typ, name):
    self.type = typ
    self.name = name

  def __json__ (self):
    d = { "_version" : 1}
    d["_type"] = self.type
    d["_name"] = self.name
    return d

  @staticmethod
  def jconstruct (obj):
    try:
      klass = POOLTYPES(obj["_type"])
      pool = klass(obj["_type"], obj["_name"])
      pool.construct(obj)
      return pool
    except KeyError:
      # Log that we don't recognize this type of pool

@pool("ipv4")
class IPv4AddressPool(AddressPool):
  def __init__ (self, name, subnet = None):
    super(IPv4AddressPool).__init__(name)

  def construct (self, obj):
    pass

@pool("ipv6")
class IPv6AddressPool(AddressPool):
  def __init__ (self, name, subnet = None):
    super(IPv6AddressPool).__init__(name)

