# Copyright (c) 2014  Barnstormer Softworks, Ltd.

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

class NetworkFunction (object):
  def __init__ (self, typ):
    self.typename = typ
    self.client_id = None

  def __json__ (self):
    return {"client-id" : self.client_id, "type" : self.typename}


def FunctionFactory(obj):
  builder = FuncReg.getJSONBuilder(obj["type"])
  vnf = builder(obj)
  vnf.client_id = obj["client-id"]
  return vnf


class FunctionRegistry(object):
  def __init__ (self):
    self._data = {}

  def registerType (self, typename, jsonbuilder, rspecbuilder):
    self._data[typename] = (jsonbuilder, rspecbuilder)

  def getJSONBuilder (self, typename):
    (jsonbuilder, rspecbuilder) = self._data[typename]
    return jsonbuilder

  def getRSpecBuilder (self, typename):
    (jsonbuilder, rspecbuilder) = self._data[typename]
    return rspecbuilder

FuncReg = FunctionRegistry()
