# Copyright (c) 2016  Barnstormer Softworks, Ltd.

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

from __future__ import absolute_import

import traceback

from flask import request

from . import data
from ..api.jsonrpc import Dispatcher, route
from ..core.json import jsonify, jsonValidate, JSONValidationError
from ..core.configdb import ConfigDB


class VTSUserAPIv1(Dispatcher):
  def __init__ (self, app):
    super(VTSUserAPIv1, self).__init__("VTS User v1", app.logger, app)
    self._log.info("Loaded")
    self._data = data.DB

  def validate (self, rjson, types):
    return jsonValidate(rjson, types, self._log)

