# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

# Copyright (c) 2013  Barnstormer Softworks, Ltd.

import json
import urllib
import urllib2

class _API(object):
  def __init__ (self, conn):
    self._conn = conn

class _Admin(_API):
  URL = "/core/admin/%s"

  @property
  def version (self):
    j = self.conn.connect(Admin.URL % ("get-version"))
    
class _Config(_API):
  URL = "/core/admin/%s"

class Connection(object):
  BASEURL = "https://%s:%d"

  def __init__ (self, host, passwd, user='foamadmin', port=3626):
    self.host = host
    self.user = user
    self.port = port
    self.__passwd = passwd

    self.__admin = _Admin(self)
    self.__config = _Config(self)

  @property
  def admin (self):
    return self.__admin

  @property
  def config (self):
    return self.__config
