import random

from mininet.topo import Topo, Node

class FoamTopo(Topo):
  def __init__ (self, enable_all = True):
    super(FoamTopo, self).__init__()

    s = [x for x in xrange(15,25)]
    for swid in s:
      self.add_node(swid, Node(is_switch=True))

    for swid in s:
      osid = random.choice(s)
      self.add_edge(swid, osid)
      osid = random.choice(s)
      self.add_edge(swid, osid)

    self.enable_all()

topos = { 'foam-topo' : (lambda: FoamTopo()) }
